//Driver station map
//Values are subject to change
#ifndef DSMAP_H
#define DSMAP_H

//Joystick ports
#define DS_JOY_LEFT_PORT 1
#define DS_JOY_RIGHT_PORT 2
#define DS_JOY_SECONDARY_PORT 3
#define DS_JOY_IOBOARD_PORT 4

//Joystick buttons
#define DS_JOYBTN_TURBO 3
#define DS_JOYBTN_SLOW 2
#define DS_JOYBTN_REVERSE 1
#define DS_JOYBTN_REVERSE_ALT 1

#define DS_JOYBTN_MANIP_IN 1
#define DS_JOYBTN_MANIP_OUT 3
#define DS_JOYBTN_ARM_PRESET_FLIP 2
#define DS_JOYBTN_PRESET_STRAIGHT 4
#define DS_JOYBTN_AUTO_OFFSET_PRESET	9	// move arm to auto offest peg height
#define DS_JOYBTN_AUTO_PRESET			13	// move arm to auto normal peg height
#define DS_JOYBTN_AUTO_LOWER_PRESET		10	// go to auto lowered offest or normal (must also press one of the above)
#define DS_JOYBTN_MINIBOT_DEPLOY		11
#define DS_JOYBTN_TUSKS_DEPLOY			12

//Debug buttons  UNDOCUMENTED -- PUT THIS ON THE CONTROLS WIKI ASAP
//Drivetrain: gyro, encoders, speed, light sensors 
#define DS_JOYBTN_DEBUG_DRIVETRAIN 6  //includes arm/drivetrain encoders, a d gyro
#define DS_JOYBTN_DEBUG_LINE 7 //Line sensors
#define DS_JOYBTN_DEBUG_ARM 8



//Secondary control presets
#define DS_PRESET_HIGH 1
#define DS_PRESET_MID 2
#define DS_PRESET_LOW 3
#define DS_PRESET_FEED 4
#define DS_PRESET_GROUND 5


//Button definitions
#define DS_BUTTON_TRIANGLE 6
#define DS_BUTTON_SQUARE 8
#define DS_BUTTON_CIRCLE 7
#define DS_BUTTON_MINIBOT_DEPLOY 9
#define DS_BUTTON_TUSKS_DEPLOY 10

//Switches
#define DS_BROKEN_MANIP 0
#define DS_BROKEN_ARM_FORWARD 1
#define DS_BROKEN_ARM_BACKWARD 2
#define DS_BROKEN_ARM_CALIBRATE 3
#define DS_DEPLOYER_TIMER_OVERRIDE 4
#define DS_ARM_ADHOC_DISABLE 5
#define DS_ARM_ENCODER_SELECT_A 6
#define DS_ARM_ENCODER_SELECT_B 7

//Extended IO analog channels
#define DS_IO_ANALOG_SWITCHBANK_CHANNEL_TOP 1
#define DS_IO_ANALOG_SWITCHBANK_CHANNEL_BOTTOM 2
#define DS_IO_ANALOG_AUTODELAY_CHANNEL 6
#define DS_IO_ANALOG_EXTRA_POT_CHANNEL 3
#define DS_IO_ANALOG_AUTOMODE_CHANNEL_TOP 4
#define DS_IO_ANALOG_AUTOMODE_CHANNEL_BOTTOM 5

#define DS_IO_AUTOMODE_DIGITAL_1 11
#define DS_IO_AUTOMODE_DIGITAL_2 12

#endif
