#ifndef PWMIT_H
#define PWMIT_H
#include "Resources.h"
class PWMit
{ 

private:

    Notifier notify;
    DigitalOutput *output;

    float secPerLoop;
    float curPercent;
    bool enabled;
    int count;



public:
    PWMit(int port, float seconds);
    PWMit(DigitalOutput *port, float seconds);
    ~PWMit();
    
    //set 0 to 100
    void setPWM(int percent);
       
    //disable also turns off notifier calc
    void disablePWM();
    void enablePWM();
    
    //check current PWM
    float getPWM();

private:
    void init(float seconds);
    //called by Notifier class
    static void calcPWM(void *this_ptr);
    void calcPWM_impl();
};

#endif
