#include "Resources.h"
#include "ThunderDeployer.h"



ThunderDeployer::ThunderDeployer(bool ctime)
{
	deployTimer     = new Timer();
	deployTimer          ->Stop();
	tusksLatch      = new Servo(SERV_TUSK_LATCH);
	tusksLatch			 ->Set(1);
	//minibotLatch    = new Servo(SERV_MINIBOT_LATCH);
	//minibotLatch		 ->Set(1);
	checktime       = ctime;
	minibotDeployed = false;
	tusksDeployed   = false;
	compressor = new Compressor(DIG_COMPRESSOR_PRESSURE, RELAY_COMPRESSOR);
	compressor->Start();
	solenoid = new Relay(RELAY_VALVE, Relay::kBothDirections);
	solenoid->Set(Relay::kReverse);
}

ThunderDeployer::~ThunderDeployer()
{
	//delete minibotLatch;
	delete compressor;
	delete solenoid;
	delete tusksLatch;
	delete deployTimer;
}

void ThunderDeployer::DeployTusks()
{
	if (GetTusksDeployed())
	{
		
	}
	if(deployTimer->Get() >= 90 || !checktime)
	{
		tusksDeployed = true;
	}
}

void ThunderDeployer::DeployMinibot()
{
	if(tusksDeployed && (deployTimer->Get() >= 100 || !checktime))
	{
		minibotDeployed = true;
	}
}

void ThunderDeployer::UndeployMinibot()
{
	minibotDeployed = false;
}
bool ThunderDeployer::GetTusksDeployed()
{
	return tusksDeployed;
}

bool ThunderDeployer::GetMinibotDeployed()
{
	return minibotDeployed;
}

void ThunderDeployer::StartMatch()
{
	deployTimer->Start();
}

void ThunderDeployer::ProcessDeployer()
{
	if(tusksDeployed)
	{
		tusksLatch->Set(0);
	}
	else
	{
		tusksLatch->Set(1);
	}
	if(minibotDeployed)
	{
		//minibotLatch->Set(0);
		solenoid->Set(Relay::kForward);
	}
	else
	{
		//minibotLatch->Set(1);
		solenoid->Set(Relay::kReverse);
	}
}


void ThunderDeployer::OverrideTimer(bool overridden)
{
	checktime = !overridden;
}

bool ThunderDeployer::MinibotReady()
{
	return deployTimer->Get() >= 100 || !checktime;
}

bool ThunderDeployer::TusksReady()
{
	return deployTimer->Get() >= 90 || !checktime;
}


void ThunderDeployer::Reset()
{
	deployTimer     ->Stop();
	deployTimer     ->Reset();
	minibotDeployed = false;
	tusksDeployed   = false; 
}
