#ifndef THUNDER_DEPLOYER_H
#define THUNDER_DEPLOYER_H
#include "Resources.h"
/*
 DEPLOY ZE MINIBOTS!!
*/

class ThunderDeployer
{
public:
	
	//pass false if wishing to not rely on clock to prevent premature deployment
	ThunderDeployer(bool checkTime=true);
	~ThunderDeployer();
	
	
	//extend tusks
	//will check to see if time is less than 15 seconds from end
	void DeployTusks();
	//deploy minibot
	//will check to see if time is less than 10 seconds from end
	void DeployMinibot();
	//reverse valve, pulls deployer back in
	void UndeployMinibot();
	
	//true if tusks have sucessfully been deployed
	bool GetTusksDeployed();
	
	//true if minibot has sucessfully been deployed
	bool GetMinibotDeployed();
	
	//call every loop to run deployment mechanisms
	void ProcessDeployer();
	
	//call when match starts to start the timer for timing failsafe
	void StartMatch();
	
	bool MinibotReady();
	
	bool TusksReady();
	
	void OverrideTimer(bool overridden);
	
	void Reset();
private:
	bool tusksDeployed;
	bool minibotDeployed;
	bool checktime;
	Timer * deployTimer;
	Servo * tusksLatch;
	//Servo * minibotLatch;
	Compressor *compressor;
	Relay *solenoid;
};

#endif
