#include "UDPLogger.h"
#include <inetLib.h>
#include <stdio.h>
#include <string.h>

#define ENABLE_UDP_LOGGER


UDPLogger::UDPLogger() : fd(0) {
}

UDPLogger::~UDPLogger() {
	if (fd)
		close(fd);
}

void UDPLogger::init(int port) {
#ifdef ENABLE_UDP_LOGGER
	memset(&saddr, 0, sizeof(saddr));
	saddr.sin_family = AF_INET;
	saddr.sin_port = htons(port);
	
	if (inet_aton("10.15.11.5", &saddr.sin_addr) == ERROR) {
		printf("UDPLogger: Bad inet_aton\n");
		return;
	}

	int tmpfd = socket(AF_INET, SOCK_DGRAM, 0);
	if (tmpfd == ERROR) {
		printf("UDPLogger: Bad socket\n");
		return;
	}	
	fd = tmpfd;
#endif
}

void UDPLogger::log(const char *fmt, ...)
{
	if (fd) {
		va_list args;
		va_start(args, fmt);
		vsprintf(buf, fmt, args);
		va_end(args);
		if (sendto(fd, buf, strlen(buf), 0, (sockaddr *)&saddr, sizeof(saddr)) == ERROR) {
			printf("UDPLogger: sendto failed\n");
		}
	}
	va_list args;
	va_start(args, fmt);
	vprintf(fmt, args);
	va_end(args);
}

